-- MySQL Script generated by MySQL Workbench
-- Sun Nov 29 10:11:18 2020
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION';

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `mydb` DEFAULT CHARACTER SET utf8 ;
USE `mydb` ;

-- -----------------------------------------------------
-- Table `mydb`.`Role`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Role` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(20) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE INDEX `name_UNIQUE` (`name` ASC))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Country`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Country` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(255) NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`City`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`City` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(255) NULL,
  `Country_id` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_City_Country_idx` (`Country_id` ASC),
  CONSTRAINT `fk_City_Country`
    FOREIGN KEY (`Country_id`)
    REFERENCES `mydb`.`Country` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Owner`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Owner` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `firstname` VARCHAR(255) NOT NULL,
  `lastname` VARCHAR(255) NOT NULL,
  `gender` ENUM('H', 'F', 'O') NULL,
  `email` VARCHAR(255) NULL,
  `address` VARCHAR(255) NULL,
  `City_id` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_Owner_City1_idx` (`City_id` ASC),
  CONSTRAINT `fk_Owner_City1`
    FOREIGN KEY (`City_id`)
    REFERENCES `mydb`.`City` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`HousingType`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`HousingType` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(255) NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Housing`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Housing` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(255) NULL,
  `adress` VARCHAR(255) NULL,
  `nb_rooms` INT NULL,
  `nb_bedrooms` INT NULL,
  `description` TEXT(1000) NULL,
  `internal_ref` VARCHAR(45) NULL,
  `surface` DECIMAL(6,2) NULL,
  `indic_energy` INT NULL,
  `indic_emission` INT NULL,
  `has_garage` TINYINT NULL,
  `has_pool` TINYINT NULL,
  `has_garden` TINYINT NULL,
  `has_balcony` TINYINT NULL,
  `City_id` INT NOT NULL,
  `Owner_id` INT NOT NULL,
  `HousingType_id` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_Housing_City1_idx` (`City_id` ASC),
  INDEX `fk_Housing_Owner1_idx` (`Owner_id` ASC),
  INDEX `fk_Housing_HousingType1_idx` (`HousingType_id` ASC),
  CONSTRAINT `fk_Housing_City1`
    FOREIGN KEY (`City_id`)
    REFERENCES `mydb`.`City` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Housing_Owner1`
    FOREIGN KEY (`Owner_id`)
    REFERENCES `mydb`.`Owner` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Housing_HousingType1`
    FOREIGN KEY (`HousingType_id`)
    REFERENCES `mydb`.`HousingType` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Media`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Media` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `url` VARCHAR(255) NOT NULL,
  `description` TEXT(1000) NULL,
  `title` VARCHAR(255) NULL,
  `Housing_id` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_Media_Housing1_idx` (`Housing_id` ASC),
  CONSTRAINT `fk_Media_Housing1`
    FOREIGN KEY (`Housing_id`)
    REFERENCES `mydb`.`Housing` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`Status`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`Status` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE INDEX `name_UNIQUE` (`name` ASC))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`User`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`User` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `login` VARCHAR(255) NOT NULL,
  `password` VARCHAR(255) NOT NULL,
  `Role_id` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_User_Role1_idx` (`Role_id` ASC),
  CONSTRAINT `fk_User_Role1`
    FOREIGN KEY (`Role_id`)
    REFERENCES `mydb`.`Role` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`HousingComment`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`HousingComment` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `content` TEXT(1000) NULL,
  `User_id` INT NOT NULL,
  `Housing_id` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_PhotoComment_User1_idx` (`User_id` ASC),
  INDEX `fk_HousingComment_Housing1_idx` (`Housing_id` ASC),
  CONSTRAINT `fk_PhotoComment_User1`
    FOREIGN KEY (`User_id`)
    REFERENCES `mydb`.`User` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_HousingComment_Housing1`
    FOREIGN KEY (`Housing_id`)
    REFERENCES `mydb`.`Housing` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`OwnerComment`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`OwnerComment` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `content` TEXT(1000) NOT NULL,
  `Owner_id` INT NOT NULL,
  `User_id` INT NOT NULL,
  PRIMARY KEY (`id`),
  INDEX `fk_OwnerComment_Owner1_idx` (`Owner_id` ASC),
  INDEX `fk_OwnerComment_User1_idx` (`User_id` ASC),
  CONSTRAINT `fk_OwnerComment_Owner1`
    FOREIGN KEY (`Owner_id`)
    REFERENCES `mydb`.`Owner` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_OwnerComment_User1`
    FOREIGN KEY (`User_id`)
    REFERENCES `mydb`.`User` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`housing_has_status`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `mydb`.`housing_has_status` (
  `Status_id` INT NOT NULL,
  `Housing_id` INT NOT NULL,
  `date` DATE NOT NULL,
  INDEX `fk_Status_has_Housing_Housing1_idx` (`Housing_id` ASC),
  INDEX `fk_Status_has_Housing_Status1_idx` (`Status_id` ASC),
  PRIMARY KEY (`Status_id`, `Housing_id`, `date`),
  CONSTRAINT `fk_Status_has_Housing_Status1`
    FOREIGN KEY (`Status_id`)
    REFERENCES `mydb`.`Status` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_Status_has_Housing_Housing1`
    FOREIGN KEY (`Housing_id`)
    REFERENCES `mydb`.`Housing` (`id`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
